/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the ActivityPatchable type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ActivityPatchable{}

// ActivityPatchable struct for ActivityPatchable
type ActivityPatchable struct {
	Attributes *map[string][]string `json:"attributes,omitempty"`
	File *ActivityPatchableFile `json:"file,omitempty"`
}

// NewActivityPatchable instantiates a new ActivityPatchable object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewActivityPatchable() *ActivityPatchable {
	this := ActivityPatchable{}
	return &this
}

// NewActivityPatchableWithDefaults instantiates a new ActivityPatchable object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewActivityPatchableWithDefaults() *ActivityPatchable {
	this := ActivityPatchable{}
	return &this
}

// GetAttributes returns the Attributes field value if set, zero value otherwise.
func (o *ActivityPatchable) GetAttributes() map[string][]string {
	if o == nil || IsNil(o.Attributes) {
		var ret map[string][]string
		return ret
	}
	return *o.Attributes
}

// GetAttributesOk returns a tuple with the Attributes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ActivityPatchable) GetAttributesOk() (*map[string][]string, bool) {
	if o == nil || IsNil(o.Attributes) {
		return nil, false
	}
	return o.Attributes, true
}

// HasAttributes returns a boolean if a field has been set.
func (o *ActivityPatchable) HasAttributes() bool {
	if o != nil && !IsNil(o.Attributes) {
		return true
	}

	return false
}

// SetAttributes gets a reference to the given map[string][]string and assigns it to the Attributes field.
func (o *ActivityPatchable) SetAttributes(v map[string][]string) {
	o.Attributes = &v
}

// GetFile returns the File field value if set, zero value otherwise.
func (o *ActivityPatchable) GetFile() ActivityPatchableFile {
	if o == nil || IsNil(o.File) {
		var ret ActivityPatchableFile
		return ret
	}
	return *o.File
}

// GetFileOk returns a tuple with the File field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ActivityPatchable) GetFileOk() (*ActivityPatchableFile, bool) {
	if o == nil || IsNil(o.File) {
		return nil, false
	}
	return o.File, true
}

// HasFile returns a boolean if a field has been set.
func (o *ActivityPatchable) HasFile() bool {
	if o != nil && !IsNil(o.File) {
		return true
	}

	return false
}

// SetFile gets a reference to the given ActivityPatchableFile and assigns it to the File field.
func (o *ActivityPatchable) SetFile(v ActivityPatchableFile) {
	o.File = &v
}

func (o ActivityPatchable) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ActivityPatchable) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Attributes) {
		toSerialize["attributes"] = o.Attributes
	}
	if !IsNil(o.File) {
		toSerialize["file"] = o.File
	}
	return toSerialize, nil
}

type NullableActivityPatchable struct {
	value *ActivityPatchable
	isSet bool
}

func (v NullableActivityPatchable) Get() *ActivityPatchable {
	return v.value
}

func (v *NullableActivityPatchable) Set(val *ActivityPatchable) {
	v.value = val
	v.isSet = true
}

func (v NullableActivityPatchable) IsSet() bool {
	return v.isSet
}

func (v *NullableActivityPatchable) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableActivityPatchable(val *ActivityPatchable) *NullableActivityPatchable {
	return &NullableActivityPatchable{value: val, isSet: true}
}

func (v NullableActivityPatchable) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableActivityPatchable) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


